unit hiPaletteBox;

interface

uses Windows,Messages,Kol,Share,Win,hiIconsManager;

type
    TDrawUnit = record
     Name : string;   // 
     Hint : string;   // 
     Icon : integer;  //  
     Mode : integer;  //  : 0 - , 1-  , 2-
     Disb : integer;  // 0 - , 1 -   
     Open : integer;  // 0 - , 1 - 
     posX : integer;  //  X    
     posY : integer;  //  Y    
end;   

type
  THIPaletteBox = class(THIWin)
   private
    ScrollControl: PControl;
    si: TScrollInfo;
    DrawUnit: array of TDrawUnit;
    FList: PStrList;
    Bmp: PBitmap;
    Arr: PArray;
    Border, tsz, HeightP, WidthP, FBoxH, FItemH, FNodeH, FActive, FSpace, FPadding: integer;
    FCFont, FNFont, FIFont: PGraphicTool;
    DownItem : boolean;

    procedure _onSize( Sender: PObj);
    procedure _onPaint( Sender: PControl; DC: HDC );
    procedure Draw;
    procedure SetText(const Value:string);
    procedure _Set(var Item:TData; var Val:TData);
    function  _Get(Var Item:TData; var Val:TData):boolean;
    function  _Count:integer;
    procedure _Add(var Val:TData);
    procedure SetNewCFont(Value:TFontRec);
    procedure SetNewNFont(Value:TFontRec);
    procedure SetNewIFont(Value:TFontRec);
    function  _MessageScroll(var Msg: TMsg; var Rslt: Integer):boolean;
    function  GetPosScroll:integer;
    procedure UpdateScroll;
    procedure SetPositionDrawUnits;        
    procedure SetValueDrawUnits;
    procedure UpdateDrawUnits(ind:integer);    
    procedure _onMouseLeave(Sender: PObj); override;
    function  GetHieght(index:integer):integer;
    procedure ReDraw(index:integer);
    procedure DrawBox(pDC: HDC; y, h, index: integer);    
    procedure DrawNode(pDC: HDC; y, h, index: integer);
    procedure DrawItem(pDC: HDC; y, h, index: integer);  
    procedure DrawFrame(pDC: HDC; IndFrame: byte; r: TRect);
    procedure DrawArrow(pDC: HDC; Op, Yar: integer);
    procedure DrawEnabled(pDC: HDC; x, y, w, h: integer);

   protected
    procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseMove(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseUp(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseWheel(Sender: PControl; var Mouse: TMouseEventData); override;
   public
    _data_FileName:THI_Event;
    _data_str:THI_Event;
    _data_Idx1:THI_Event;    
    _data_Idx2:THI_Event;
    _prop_FileName:string;
    _prop_WidthScroll:integer;
    _prop_SingleExpand:boolean;
    _prop_AlignBox:byte;
    _prop_ArrowBox:boolean;
    _prop_FlatBox:boolean;
    _prop_HeightBox:integer;
    _prop_IconsBox:IIconsManager;
    _prop_AlignNode:byte;
    _prop_ArrowNode:boolean;
    _prop_HeightNode:integer;
    _prop_ViewItem:byte;
    _prop_FlatItem:boolean;
    _prop_Frame:boolean;
    _prop_Space:integer;
    _prop_Padding:integer;
    _prop_HeightItem:integer;
    _prop_Edge:byte;
    _prop_IconsItem:IIconsManager;
    _event_onChange:THI_Event;
    _event_onClick:THI_Event;

    constructor Create(Parent:PControl);
    destructor Destroy; override;
    procedure Init; override;
    procedure _work_doAdd(var _Data:TData; Index:word);
    procedure _work_doInsert(var _Data:TData; Index:word);
    procedure _work_doReplace(var _Data:TData; Index:word);
    procedure _work_doMove(var _Data:TData; Index:word);
    procedure _work_doSwap(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doText(var _Data:TData; Index:word);
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _work_doEnabled(var Data:TData; Index:word);
    procedure _work_doCollapse(var _Data:TData; Index:word);
    procedure _work_doExpand(var _Data:TData; Index:word);
    procedure _work_doChangeIcon(var _Data:TData; Index:word);
    procedure _work_doDisable(var _Data:TData; Index:word);
    procedure _var_Text(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_Array(var _Data:TData; Index:word);
    procedure _var_Index(var _Data:TData; Index:word);
    procedure _var_EndInd(var _Data:TData; Index:word);
    procedure _var_String(var _Data:TData; Index:word);
    procedure _var_View(var _Data:TData; Index:word);
    property _prop_Strings:string write SetText;
    property _prop_FontBox:TFontRec write SetNewCFont;
    property _prop_FontNode:TFontRec write SetNewNFont;
    property _prop_FontItem:TFontRec write SetNewIFont;  
  end;

implementation

constructor THIPaletteBox.Create(Parent:PControl);
begin
   inherited Create(Parent);
   FList := NewStrList;
   Control := NewPaintbox(Parent);
   Bmp := NewBitmap(0,0);
   Bmp.Width := max(Control.Width,1);
   Bmp.Height := max(Control.Height,1);
   SetClassLong(Control.Handle,GCL_STYLE,GetClassLong(Control.GetWindowHandle,GCL_STYLE) and not CS_DBLCLKS);
end;

destructor THIPaletteBox.Destroy;
begin
   Bmp.Free;   
   FList.Free;
   FCFont.Free;
   FNFont.Free;
   FIFont.Free;
   if Arr <> nil then Dispose(Arr); 
   inherited;
end;

procedure THIPaletteBox.Init;
begin
   ScrollControl := _NewControl(Control, 'SCROLLBAR', WS_VISIBLE or WS_CHILD or SBS_VERT, FALSE, nil );
   OldMes := Control.OnMessage;
   Control.OnMessage := _MessageScroll;
   inherited;
   with Control{$ifndef F_P}^{$endif} do begin
    OnPaint := _OnPaint;
    OnResize := _OnSize;
   end;
   if _prop_Ctl3D = 1 then Border := 0 else
    case Control.ExStyle of
     WS_EX_LTRREADING:    border := 0;
     WS_EX_STATICEDGE:    border := 2;
     WS_EX_DLGMODALFRAME: border := 6;
     WS_EX_CLIENTEDGE OR WS_EX_DLGMODALFRAME : border := 10;
     else border := 4;
    end;
   FBoxH := _prop_Heightbox;
   FNodeH := _prop_HeightNode;
   FItemH := _prop_HeightItem;
   FActive := -1;
   DownItem := False;
   FSpace := _prop_Space;
   FPadding := _prop_Padding;   
   SetValueDrawUnits;
   Control.OnMouseLeave :=_OnMouseLeave;
   Control.onMouseWheel  := _onMouseWheel;  
   si.nMin := 0;
   ScrollControl.Visible := False;
   ScrollControl.Color := Color2RGB(clBtnHighlight);
   ScrollControl.Width := _prop_WidthScroll;
   si.cbSize := sizeof(si);
   UpdateScroll;
   WidthP := Control.Width;
   _OnSize(Control);
   _prop_Hint := ' ';
   SetHintManager(fHint);
   if assigned(_prop_HintManager) then _prop_HintManager.hint(hid, '');
end;

function THIPaletteBox._MessageScroll;
begin
  Result := false;
  case Msg.message of WM_HSCROLL,WM_VSCROLL:
    if dword(Msg.lParam) = ScrollControl.Handle then
    begin
     GetPosScroll;
     case LOWORD(Msg.wParam)  of
      SB_BOTTOM,SB_LINERIGHT: if si.nPos < si.nMax then inc(si.nPos);
      SB_LINELEFT,SB_TOP:     if si.nPos > si.nMin then dec(si.nPos);
      SB_PAGELEFT:            dec(si.nPos, 32);
      SB_PAGERIGHT:           inc(si.nPos, 32);
      SB_THUMBPOSITION,
      SB_THUMBTRACK:          si.nPos := si.nTrackPos;
     end;
     UpdateScroll;
     Control.Invalidate;
     result := true;
     Rslt := 0;
    end;
  end;
  Result := Result;
end;

function THIPaletteBox.GetPosScroll;
begin
   si.fMask := SIF_POS or SIF_TRACKPOS;
   GetScrollInfo(ScrollControl.Handle,SB_CTL,si);
   Result := si.nPos;
end;

procedure THIPaletteBox.UpdateScroll;
begin
   si.fMask := SIF_RANGE or SIF_PAGE or SIF_POS;
   si.nMax := HeightP - Control.Height;
   SetScrollInfo(ScrollControl.Handle,SB_CTL,si,false);
   ScrollControl.Invalidate;
end;

procedure THIPaletteBox.SetValueDrawUnits;
var       pos, i, j: integer;
          val, str :string;
begin
  if FList.Count = 0 then exit; 
  SetLength(DrawUnit, FList.Count);
  for i := 0 to FList.Count-1 do begin
   str := FList.Items[i];
   for j := 0 to 5 do begin
    pos := PosEx(';',str,1) - 1;
    if pos = -1 then pos := Length(str);
    val := Copy(str,1,pos);
    case j of
     0: begin
         DrawUnit[i].Mode := str2int(val);    //: 1 - , 2 -  , 3 - 
         if (DrawUnit[i].Mode < 1) or (DrawUnit[i].Mode > 3) then  //       1-3
          begin
           DrawUnit[i].Mode := 3;
           str:= ';' + str;
          end;
        end;
     1: DrawUnit[i].Name := val;          //
     2: DrawUnit[i].Hint := val;          //
     3: DrawUnit[i].Icon := str2int(val); //  
     4: DrawUnit[i].Open := str2int(val); //0 - , 1 - 
     5: DrawUnit[i].Disb := str2int(val); //0 - , 1 - 
    end;
    Delete(str,1,pos + 1);
   end;
  end;
end;

procedure THIPaletteBox.UpdateDrawUnits; //   DrawUnit c      FList
begin
   FList.Delete(ind);
   FList.Insert(ind, int2str(DrawUnit[ind].Mode) + ';' + DrawUnit[ind].Name + ';' + DrawUnit[ind].Hint + ';' + 
                     int2str(DrawUnit[ind].Icon) + ';' + int2str(DrawUnit[ind].Open) + ';' + int2str(DrawUnit[ind].Disb)); 
end;

procedure THIPaletteBox._work_doAdd;
var str: string;
begin
    str := ReadString(_Data,_data_str,''); 
    if str = '' then exit;
    FList.Add(str);
    SetValueDrawUnits;
    _OnSize(Control);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doClear;
begin
    SetLength(DrawUnit, 0);
    FList.Clear;
    FActive := (-1);
   _OnSize(Control);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doDelete;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if (ind < 0) or (ind > FList.Count - 1) then exit;
   FList.Delete(ind);
   SetValueDrawUnits;
   _OnSize(Control);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doInsert;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if (ind < -1) or (ind > FList.Count) then exit
   else if ind = -1 then ind := FList.Count; 
   FList.Insert(ind, ReadString(_Data, _data_str, ''));
   SetValueDrawUnits;
   _OnSize(Control);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doReplace;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if (ind < 0) or (ind > FList.Count - 1) then exit;
   FList.Delete(ind);
   FList.Insert(ind, ReadString(_Data, _data_str, ''));   
   SetValueDrawUnits;
   _OnSize(Control);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doMove;
var
  ind1, ind2 :integer;
begin
   ind1 := ReadInteger(_Data, _data_Idx1);
   ind2 := ReadInteger(_Data, _data_Idx2);
   if (ind1 < 0) or (ind1 > FList.Count - 1) or (ind2 < 0) or (ind2 > FList.Count - 1) then exit;
   FList.Move(ind1, ind2);
   SetValueDrawUnits;
   _OnSize(Control);
    if assigned(_prop_HintManager) then _prop_HintManager.hint(hid, DrawUnit[FActive].Hint);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doSwap;
var
  ind1, ind2 :integer;
begin
   ind1 := ReadInteger(_Data, _data_Idx1);
   ind2 := ReadInteger(_Data, _data_Idx2);
   if (ind1 < 0) or (ind1 > FList.Count - 1) or (ind2 < 0) or (ind2 > FList.Count - 1) then exit;
   FList.Swap(ind1, ind2);
   SetValueDrawUnits;
   _OnSize(Control);
   if assigned(_prop_HintManager) then _prop_HintManager.hint(hid, DrawUnit[FActive].Hint);
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure THIPaletteBox._work_doText;
begin
   FList.SetText(ReadString(_Data,_data_str), false);
   SetValueDrawUnits;
   _OnSize(Control);
end;

procedure THIPaletteBox._work_doLoad;
var   fn:string;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if FileExists(fn) then begin
      FList.LoadFromFile(fn);
   end;
   SetValueDrawUnits;
   _OnSize(Control);
end;

procedure THIPaletteBox._work_doSave;
var   fn:string;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   FList.SaveToFile(fn);
end;

procedure  THIPaletteBox._work_doEnabled;
begin
   Control.Enabled := ReadBool(Data);
   ScrollControl.Enabled := ReadBool(Data);
   Control.Invalidate;
end;

procedure THIPaletteBox.SetText;
begin
   FList.SetText(Value, false);
end;

function THIPaletteBox.GetHieght;
var x : integer;
begin
 x := 0;
 Case DrawUnit[index].Mode of
  1 :  x := FBoxH; 
  2 :  x := FNodeH;
  3 :  x := FItemH;
 end; 
 Result := x;
end;

procedure THIPaletteBox.SetPositionDrawUnits;
var i, y, x: integer;
    op, opn, it: boolean;
begin
    if Length(DrawUnit) = 0 then exit;
    y := 0; 
    x := FPadding + 2; //     ()   (    ) 
    op  := true;       //  
    opn := true;       //   
    it := false;       //    
    i := 0;
    while i <> Length(DrawUnit) do begin
     if ((DrawUnit[i].Mode = 1) or (DrawUnit[i].Mode = 2)) and it then begin  //  a    ,  
      x := FPadding + 2;         
      if (_prop_ViewItem = 1) then y := y + FItemH + FPadding + 2 else y := y + FPadding;
      it := false;      
     end;
     case DrawUnit[i].Mode of 
      1 : begin // 
           if _prop_SingleExpand and (DrawUnit[i].Open = 1)
            and (i <> FActive) and (DrawUnit[FActive].Mode = 1) then DrawUnit[i].Open := 0; 
           if DrawUnit[i].Open = 1 then begin
            op  := true;
            opn := true;
           end else begin
            op  := false;
            opn := false;
           end;
           DrawUnit[i].posY := y;
           DrawUnit[i].posX := 0;
           y := y + FBoxH; 
           if it then it := false;
          end;
      2 : begin //  
           if op then begin
            if DrawUnit[i].Open < 0 then DrawUnit[i].Open := DrawUnit[i].Open + 2;
            if DrawUnit[i].Open = 1 then  opn := true else opn := false;
            DrawUnit[i].posY := y; 
            DrawUnit[i].posX := 1;
            y := y + FNodeH;
           end else begin
            if DrawUnit[i].Open > 0 then DrawUnit[i].Open := DrawUnit[i].Open - 2;
            DrawUnit[i].posY := -100; 
           end;
           if it then it := false;
          end;
      3 : begin // 
           if op and opn then begin
            DrawUnit[i].Open := 1;
            if not it then begin
             it := true;
             y := y + FPadding + 2;
            end;   
            if ((x + FItemH + FPadding + 2) > WidthP) and (i > 0) then begin
             x := FPadding + 2;
             y := y + FItemH + FSpace;                  
            end;              
            DrawUnit[i].posY := y; 
            DrawUnit[i].posX := x;               
            if (_prop_ViewItem = 1) then x := x + FItemH + FSpace else y := y + FItemH + FSpace;  
           end else begin
            DrawUnit[i].posY := -HeightP; 
            DrawUnit[i].posX := 0;
            DrawUnit[i].Open := 0;
           end; 
          end;                      
    end;
    Inc(i);
   end;
   if (Length(DrawUnit) > 0) and (DrawUnit[i-1].Mode = 3) and
      (DrawUnit[i-1].Open = 1) and (_prop_ViewItem = 1) then y := y + FItemH + FPadding; 
   HeightP := y + border + 2;
   if HeightP > Control.Height then begin
    WidthP := Control.Width - ScrollControl.Width - border;
    ScrollControl.Visible := True;
    if si.nPos > HeightP - Control.Height then si.nPos := HeightP - Control.Height;
    UpdateScroll;
   end else begin
    WidthP := Control.Width - border;
    ScrollControl.Visible := False;
    si.nPos := 0;
    UpdateScroll;
   end;
end;

procedure THIPaletteBox._onSize;
begin
   SetPositionDrawUnits;
   ScrollControl.Height := Control.Height - border;     
   ScrollControl.Left := Control.Width - ScrollControl.Width - border;
   SetPositionDrawUnits;
   Bmp.Width := max(Control.Width,1);
   Bmp.Height := max(Control.Height,1);
   Control.Invalidate;
end;

procedure THIPaletteBox._onPaint;
begin
   Draw;
   Bmp.Draw(DC,0,0);
end;

procedure THIPaletteBox._onMouseLeave;
var old : integer;
begin
   inherited;
   if DownItem then DownItem := False;
   if FActive <> (-1) then begin
    old := FActive;
    FActive := -1;
    ReDraw(old);
   end;
end;

procedure THIPaletteBox._onMouseMove;
var i, x, y, w, h:integer;
begin
 inherited;
 if Length(DrawUnit) = 0 then exit; 
 i := 0;
 w := WidthP; 
 while i < Length(DrawUnit) do
  begin
   y := DrawUnit[i].posY;
   x := DrawUnit[i].posX;
   h := GetHieght(i); 
   case DrawUnit[i].Mode of
    1: w := WidthP;
    2: w := WidthP - 1;
    3: if (_prop_ViewItem = 1)then w := x + FItemH;  
        else
         begin
          w := WidthP - FPadding;
          x := FPadding;
         end;
   end;
   if (Mouse.y > y - si.nPos)and(Mouse.y < y + h - si.nPos)and(Mouse.x > x)and(Mouse.x < w) then
    if (DrawUnit[i].Disb = 0) or (DrawUnit[i].Mode <> 3) then
     begin
      if i <> FActive then
       begin
        if assigned(_prop_HintManager) then _prop_HintManager.hint(hid, DrawUnit[i].Hint);
        if FActive <> (-1) then Redraw(FActive);
        FActive := i;
        Redraw(FActive);
        Break;
       end
      else Break;
     end; 
    Inc(i);
  end; 
  //       ,      
  if ((Mouse.x > WidthP) or (Length(DrawUnit) = i)) and (FActive <> (-1)) then
   begin
    Redraw(FActive);
    FActive := -1;
    if assigned(_prop_HintManager) then _prop_HintManager.hint(hid, '');
    if DownItem then DownItem := False;
   end;
end;

procedure THIPaletteBox._onMouseDown;
var i, v, x, y, h, w: integer;
begin
  inherited;
  Control.Focused := true;    ///////////////////////    
  if Length(DrawUnit) = 0 then exit; 
  if (integer(Ms.Button)-1) = 0 then begin
   i := 0;
   w := WidthP;  
   while i <> Length(DrawUnit) do begin
    v := DrawUnit[i].Mode;  
    y := DrawUnit[i].posY;
    x := DrawUnit[i].posX;
    h := GetHieght(i); 
    case v of
     1: w := WidthP;
     2: w := WidthP - 1;
     3: if (_prop_ViewItem = 1)then w := x + FItemH;  
        else begin w := WidthP - FPadding; x := FPadding; end;
    end;
    if (Mouse.y > y - si.nPos) and (Mouse.y < y + h - si.nPos) and  (Mouse.x > x) and (Mouse.x < w) then
     if (DrawUnit[i].Disb = 0) or (v <> 3) then begin
      DownItem := True;
      if (v = 1) or (v = 2) then begin
       if DrawUnit[i].Open = 1 then DrawUnit[i].Open := 0 else DrawUnit[i].Open := 1;
       UpdateDrawUnits(i);
       _OnSize(Control);
       Control.Invalidate;
      end else Redraw(i);
      if v = 3 then _hi_onEvent(_event_onClick, DrawUnit[i].Name);
      Break;
     end; 
     Inc(i);
    end;   
  end;
end;

procedure THIPaletteBox._onMouseUp;
begin
  if DownItem and (Mouse.Button = mbLeft) then begin
   DownItem := False;
   ReDraw(FActive);
  end;
  _hi_onEvent(_event_onMouseUp,integer(Ms.Button));
end;

procedure THIPaletteBox._onMouseWheel;
var old, i:integer;
begin
   inherited;
   if HeightP > Control.Height then begin
    i := integer(Mouse.Shift) div $100000;
    if i > 0 then i := 1 else i:= -1;  
    old := si.nPos;
    si.nPos := si.nPos - i * FItemH;
    if si.nPos > si.nMax then si.nPos:= si.nMax;
    if si.nPos < 0 then si.nPos:= 0;   
    UpdateScroll; 
    if old <> si.nPos then Control.Invalidate;
   end;
end;

procedure THIPaletteBox.DrawEnabled;
var y1: integer;
begin
//   SetDCPenColor(pDC, GetSysColor(COLOR_BTNFACE)); // ???? FPC !!!!
//   SelectObject(pDC, GetStockObject(DC_PEN));     /// ???? FPC !!!!
   y1 := y;
   while x < w do begin
    y := y1;
    while y < h do begin
     MoveToEx(pDC, x, y, nil);
     LineTo(pDC, x+2, y+2);
     inc(y,2);
    end;
    inc(x,2);
   end;
end;

procedure THIPaletteBox.DrawFrame;
begin
   Case IndFrame of
    0: DrawEdge(pDC,r,BDR_RAISED,BF_RECT);                  // 
    1: DrawEdge(pDC,r,BDR_SUNKEN,BF_RECT);                  // 
    2: FrameRect(pDC,r,GetSysColorBrush(COLOR_BTNSHADOW));  // 
   end;
end;

procedure THIPaletteBox.DrawArrow;
var Points: array[0..2] of Tpoint;
begin
     SelectObject(pDC, GetStockObject(BLACK_BRUSH));
     SelectObject(pDC, GetStockObject(BLACK_PEN));
     if Op = 0 then begin
       Points[0]:= MakePoint(WidthP - 11, Yar - 3);    
       Points[1]:= MakePoint(WidthP - 11, Yar + 3);
       Points[2]:= MakePoint(WidthP - 8, Yar);
      end else begin
       Points[0]:= MakePoint(WidthP - 6, Yar - 2);
       Points[1]:= MakePoint(WidthP - 12, Yar - 2);
       Points[2]:= MakePoint(WidthP - 9, Yar + 1);
      end;
     Polygon(pDC, Points,3);
end;

procedure THIPaletteBox.DrawBox;
var     IList : PImageList;
        imgsz: integer;
        Rect: TRect;
        flag: Cardinal;
begin
    flag := DT_WORD_ELLIPSIS or DT_SINGLELINE or DT_VCENTER;
    SetRect(Rect,0,y,WidthP, h);
    if FActive = index
     then FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNHIGHLIGHT))
     else FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNFACE));
    if not _prop_FlatBox then DrawFrame(pDC, 0, Rect);
    if Assigned(_prop_IconsBox) then
     begin
      IList := _prop_IconsBox.iconList;
      if not Assigned(IList) then exit;
      imgsz := _prop_IconsBox.imgsz;  
      IList.Draw(DrawUnit[index].Icon, pDC, 4, y +(FBoxH - imgsz) div 2); 
     end
    else imgsz := 0;    
    SetTextColor(pDC, FCFont.Color);
    SelectObject(pDC, FCFont.Handle);
    if _prop_ArrowBox then
     begin
      DrawArrow (pDC, DrawUnit[index].Open, y + FBoxH div 2); //  
      Rect.Right := Rect.Right - 16;
     end;
    case _prop_AlignBox of
     0: flag := flag or DT_LEFT;
     1: flag := flag or DT_RIGHT;        
     2: flag := flag or DT_CENTER;
    end;                                                                   
    Rect.Left := 6 + imgsz;
    Rect.Right := Rect.Right - 4;
    DrawText(pDC,PChar(DrawUnit[index].Name), -1, Rect, flag); //   
end;

procedure THIPaletteBox.DrawNode;
var   Rect: TRect;
      flag: Cardinal;
begin
    flag := DT_WORD_ELLIPSIS or DT_SINGLELINE or DT_VCENTER;
    SetRect(Rect,0,y + 1,WidthP,h -1);
    if index = FActive
     then FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNHIGHLIGHT))
     else FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNSHADOW));              
    SetTextColor(pDC, FNFont.Color);
    SelectObject(pDC, FNFont.Handle);
    Rect.Left := 6;
    Rect.Right := Rect.Right - 4;
    if _prop_ArrowNode then
     begin
      DrawArrow (pDC, DrawUnit[index].Open, y + FNodeH div 2);
      Rect.Right := Rect.Right - 16;
     end;
    case _prop_AlignNode of
     0: flag := flag or DT_LEFT;
     1: flag := flag or DT_RIGHT;        
     2: flag := flag or DT_CENTER;
    end;                                                                   
    DrawText(pDC,PChar(DrawUnit[index].Name), -1, Rect, flag);  //    
end;

procedure THIPaletteBox.DrawItem;
var     IList : PImageList;
        imgsz, x, w, yc, sel: integer;
        Rect: TRect;
begin
  x := DrawUnit[index].posX;
  if (_prop_ViewItem = 0) then
   begin  //   
    w := WidthP - FPadding - 2;
    SetRect(Rect,x,y,w,h);
    if index = FActive
     then FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNHIGHLIGHT))
     else FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNFACE));                                    
    if  (index = FActive) and DownItem
     then sel := 1
     else sel := 0; 
    SetTextColor(pDC, FIFont.Color);                                         
    SelectObject(pDC, FIFont.Handle);
    if Assigned(_prop_IconsItem) then
     begin
      IList := _prop_IconsItem.iconList;
      imgsz := _prop_IconsItem.imgsz;  
      yc := (FItemH - imgsz) div 2 + sel;
      IList.Draw(DrawUnit[index].Icon, pDC, x + yc + 2, y + yc); 
    end
    else imgsz := 0; 
    yc := (FItemH - tsz) div 2 + sel; 
    TextOut(pDC, x + imgsz + yc + 2, y + yc, PChar(DrawUnit[index].Name), Length(DrawUnit[index].Name));
   end
  else
   begin                 //  
    w := x + FItemH;
    SetRect(Rect,x,y,w,h);
    if index = FActive
     then FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNHIGHLIGHT))
     else FillRect(pDC,Rect,GetSysColorBrush(COLOR_BTNFACE));  
    if Assigned(_prop_IconsItem) then
     begin
      IList := _prop_IconsItem.iconList;
      imgsz := _prop_IconsItem.imgsz;  
      yc := (FItemH - imgsz) div 2;
      if (FActive = index) and DownItem then yc := yc + 1; 
      IList.Draw(DrawUnit[index].Icon, pDC, x + yc, y + yc); 
     end;      
   end;
  if not(_prop_FlatItem) then        //  
   if index = FActive then
    if DownItem then DrawFrame(pDC, 1, Rect) else DrawFrame(pDC, 0, Rect)
   else DrawFrame(pDC, 0, Rect);
  if (_prop_FlatItem) and (_prop_Frame) and (FActive = index) then DrawFrame(pDC, 2, Rect);
  if (DrawUnit[index].Disb = 1) and Control.Enabled then DrawEnabled(pDC, x, y, w, h);
end;

procedure THIPaletteBox.Draw; //   
var yFrame, y, h, i: integer;
    pDC: HDC;
    Frame: boolean;
 
  function GroupItemFrame(yFr,hFr:integer):boolean;
  var     r: TRect;
  begin
    SetRect(r,-1,yFr - 2,WidthP + 1,hFr + 1);
    if _prop_Edge <> 0 then DrawFrame(pDC,_prop_Edge - 1,r); 
    Result := false;
  end;

begin
    Bmp.BkColor := Control.Color;
    Bmp.Canvas.Brush.BrushStyle := bsSolid;
    Bmp.Canvas.FillRect(Bmp.BoundsRect);
    tsz := Bmp.Canvas.TextExtent('W').cy; 
    if Length(DrawUnit) = 0 then exit;
    pDC := Bmp.Canvas.Handle;
    SetBkMode(pDC, TRANSPARENT);
    Frame := false;
    yFrame := 0;     //   
    for i := 0 to  Length(DrawUnit) do begin                               //   
     y := DrawUnit[i].posY - si.nPos;
     h := y + GetHieght(i);
     if y > Control.Height then break;
     Case DrawUnit[i].Mode of
      1: begin 
          DrawBox(pDC, y, h, i);                                           //   
          if Frame then Frame := GroupItemFrame(yFrame,y);                 //        
         end;                                                          
      2: begin
          if (DrawUnit[i].Open = 1) or (DrawUnit[i].Open = 0)
           then DrawNode(pDC, y, h, i);                                    //   
          if Frame then Frame := GroupItemFrame(yFrame,y);                 //         
         end;
      3:  if DrawUnit[i].Open = 1 then begin                                            
           DrawItem(pDC, y, h, i);                                         //   
           if not Frame then                                               //     ,   (yFrame)   
            begin
             Frame := true;
             yFrame := y - FPadding;
            end;
          end;
     end;
    end;                                                                           
    if Frame then GroupItemFrame(yFrame,HeightP - border - 1);             //    
    if not Control.Enabled then DrawEnabled(pDC, 0, 0, WidthP, HeightP);
end;

procedure THIPaletteBox.Redraw;
var r: TRect;
    h: integer;
begin
   h := GetHieght(index); 
   r.Top := DrawUnit[index].posY - si.nPos;
   r.Left := DrawUnit[index].posX;
   if DrawUnit[index].Mode = 3 then 
    if _prop_ViewItem = 0 then r.Right := WidthP - _prop_Padding
     else r.Right := DrawUnit[index].posX + h + 1
   else r.Right := WidthP;  
   r.Bottom := DrawUnit[index].posY - si.nPos + h;
   InvalidateRect(Control.Handle, @r, false);
end;

procedure THIPaletteBox._work_doCollapse;  //    (   v = TRUE)
var i: integer;
    v: boolean;
begin
    v := ReadBool(_data);
    if Length(DrawUnit) = 0 then exit;
    for i := 0 to  Length(DrawUnit) do
     if (DrawUnit[i].Mode = 1) or ((DrawUnit[i].Mode = 2) and v) then begin
      DrawUnit[i].Open := 0; 
      UpdateDrawUnits(i);
     end;
    SetPositionDrawUnits;
    Control.Invalidate;
end;

procedure THIPaletteBox._work_doExpand; //    (   v = TRUE)
var i: integer;
    v: boolean;
begin
    v := ReadBool(_data);
    if Length(DrawUnit) = 0 then exit;
    for i := 0 to  Length(DrawUnit) do
     if (DrawUnit[i].Mode = 1) or ((DrawUnit[i].Mode = 2) and v) then begin
      DrawUnit[i].Open := 1; 
      UpdateDrawUnits(i);
     end;
    SetPositionDrawUnits;
    Control.Invalidate;
end;

procedure THIPaletteBox._work_doChangeIcon; //       Inx1
var ind1, ind2: integer;
begin
    ind1 := ReadInteger(_Data, _data_Idx1);
    ind2 := ReadInteger(_Data, _data_Idx2);
    if (Length(DrawUnit) = 0) or (ind1 < 0) or (ind1 > Length(DrawUnit) - 1) or (ind2 < 0) or (ind2 > Length(DrawUnit) - 1) then exit;
    if (DrawUnit[ind1].Mode = 1) or (DrawUnit[ind1].Mode = 3) then begin
     DrawUnit[ind1].Icon := ind2; 
     UpdateDrawUnits(ind1);
    end else exit;
    Redraw(ind1);
end;

procedure THIPaletteBox._work_doDisable; // /  
var ind1, ind2: integer;
begin
    ind1 := ReadInteger(_Data, _data_Idx1);
    ind2 := ReadInteger(_Data, _data_Idx2);
    if (ind1 < 0) or (ind1 > Length(DrawUnit) - 1) then exit;
    if DrawUnit[ind1].Mode = 3 then begin
     if ind2 = 0 then DrawUnit[ind1].Disb := 0 else DrawUnit[ind1].Disb := 1; 
     UpdateDrawUnits(ind1);
    end else exit;
    Redraw(ind1);
end;

procedure THIPaletteBox.SetNewCFont;
begin
   if Assigned(FCFont) then FCFont.free;
   FCFont := NewFont;
   FCFont.Color:= Value.Color;
   Share.SetFont(FCFont,Value.Style);
   FCFont.FontName:= Value.Name;
   FCFont.FontHeight:= _hi_SizeFnt(Value.Size);
   FCFont.FontCharset:= Value.CharSet;
end;

procedure THIPaletteBox.SetNewNFont;
begin
   if Assigned(FNFont) then FNFont.free;
   FNFont := NewFont;
   FNFont.Color:= Value.Color;
   Share.SetFont(FNFont,Value.Style);
   FNFont.FontName:= Value.Name;
   FNFont.FontHeight:= _hi_SizeFnt(Value.Size);
   FNFont.FontCharset:= Value.CharSet;
end;

procedure THIPaletteBox.SetNewIFont;
begin
   if Assigned(FIFont) then FIFont.free;
   FIFont := NewFont;
   FIFont.Color:= Value.Color;
   Share.SetFont(FIFont,Value.Style);
   FIFont.FontName:= Value.Name;
   FIFont.FontHeight:= _hi_SizeFnt(Value.Size);
   FIFont.FontCharset:= Value.CharSet;
end;

procedure THIPaletteBox._var_Text;
begin
   dtString(_Data,FList.Text);
end;

procedure THIPaletteBox._var_Count;
begin
  dtInteger(_Data,FList.Count);
end;

procedure THIPaletteBox._var_Index;
begin
  dtInteger(_Data,FActive);
end;

procedure THIPaletteBox._var_EndInd;
begin
  dtInteger(_Data,FList.Count - 1);
end;

procedure THIPaletteBox._var_String;
begin
  dtString(_Data,FList.Items[FActive]);
end;

procedure THIPaletteBox._Set;
var   ind:integer;
begin
   ind := ToIntIndex(Item);                  
   if (ind >= 0) and (ind < FList.Count) then FList.Items[ind] := ToString(Val);
   SetValueDrawUnits;
   _OnSize(Control);
end;

procedure THIPaletteBox._Add;
begin
   FList.Add(ToString(val));
   SetValueDrawUnits;
   _OnSize(Control);
end;

function THIPaletteBox._Get;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if (ind >= 0) and (ind < FList.Count) then
    begin
     Result := true;
     dtString(Val,FList.Items[ind]);
    end
   else Result := false;
end;

function THIPaletteBox._Count;
begin
   Result := FList.Count;
end;

procedure THIPaletteBox._var_Array;
begin
   if Arr = nil then Arr := CreateArray(_Set, _Get, _Count, _Add);
   dtArray(_Data,Arr);
end;

procedure THIPaletteBox._var_View;
begin
   if FActive <> -1 then  dtInteger(_Data,DrawUnit[FActive].Mode)
    else dtInteger(_Data,-1);
end;

end.